<template>
  <div>
    <v-card-title> </v-card-title>
    <v-data-table
      data-app
      :headers="headers"
      :items="trainers"
      :search="search"
      sort-by="trainerId"
      class="elevation-1"
      loading
      loading-text="Loading... Please wait"
      @current-items="getFiltered"
    >
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Trainers</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <download-csv
            class="btn btn-default"
            :data="filteredData"
            name="trainers.csv"
          >
            Download CSV
          </download-csv>
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Search"
            single-line
            hide-details
          ></v-text-field>
          <v-dialog v-model="dialog" max-width="500px">
            <v-card>
              <v-card-title>
                <span class="headline">{{ formTitle }}</span>
              </v-card-title>
              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field
                        v-model="editedItem.trainerId"
                        label="TrainerId"
                        disabled
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field
                        v-model="editedItem.firstName"
                        label="First name"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field
                        v-model="editedItem.middleName"
                        label="Middle name"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field
                        v-model="editedItem.lastName"
                        label="Last name"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field
                        v-model="editedItem.address"
                        label="Address"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-menu
                        ref="menu"
                        v-model="menu"
                        :close-on-content-click="false"
                        :return-value.sync="editedItem.dob"
                        transition="scale-transition"
                        offset-y
                        min-width="auto"
                      >
                        <template v-slot:activator="{ on, attrs }">
                          <v-text-field
                            v-model="editedItem.dob"
                            label="Picker in menu"
                            prepend-icon="mdi-calendar"
                            readonly
                            v-bind="attrs"
                            v-on="on"
                          ></v-text-field>
                        </template>
                        <v-date-picker
                          v-model="editedItem.dob"
                          no-title
                          scrollable
                        >
                          <v-spacer></v-spacer>
                          <v-btn text color="primary" @click="menu = false">
                            Cancel
                          </v-btn>
                          <v-btn
                            text
                            color="primary"
                            @click="$refs.menu.save(editedItem.dob)"
                          >
                            OK
                          </v-btn>
                        </v-date-picker>
                      </v-menu>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field
                        v-model="editedItem.email"
                        label="E-mail"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field
                        v-model="editedItem.phone"
                        label="Phone"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field
                        v-model="editedItem.postalCode"
                        label="Postal Code"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-checkbox v-model="editedItem.isActive" label=" Active">
                      </v-checkbox>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue darken-1" text @click="close">
                  Cancel
                </v-btn>
                <v-btn color="blue darken-1" text @click="save"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:item.actions="{ item }">
        <v-icon small class="mr-2" @click="editItem(item)"> mdi-pencil </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initialize"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>

<script>
import trainer from "../controllers/trainer.controller";
import swal from "sweetalert2";

export default {
  name: "Trainer",
  data: () => ({
    menu: false,
    modal: false,
    menu2: false,
    filteredData: [],
    search: "",
    options: [
      {
        value: "true",
      },
      {
        value: "false",
      },
    ],
    dialog: false,
    dialogDelete: false,
    headers: [
      {
        text: "Trainer Id",
        align: "start",
        sortable: true,
        value: "trainerId",
      },
      { text: "First name", value: "firstName" },
      { text: "Middle name", value: "middleName" },
      { text: "Last name", value: "lastName" },
      { text: "Address", value: "address" },
      { text: "DOB", value: "dob" },
      { text: "Email", value: "email" },
      { text: "Phone", value: "phone" },
      { text: "Postal code", value: "postalCode" },
      { text: "Active", value: "isActive" },
      { text: "Actions", value: "actions", sortable: false },
    ],
    trainers: [],
    editedIndex: -1,
    editedItem: {
      trainerId: 0,
      firstName: "",
      middleName: "",
      lastName: "",
      address: "",
      dob: "",
      email: "",
      postalCode: "",
    },
  }),

  computed: {
    formTitle() {
      return this.editedIndex === -1 ? "New Item" : "Edit Item";
    },
  },

  watch: {
    dialog(val) {
      val || this.close();
    },
    dialogDelete(val) {
      val || this.closeDelete();
    },
  },

  created() {
    this.initialize();
  },

  methods: {
    async initialize() {
      try {
        const res = await trainer.getTrainers();
        if (res) {
          this.trainers = res.filter((trainer) => {
            return trainer.activationStatus === "Accepted";
          });
          this.trainers.forEach((trainer) => {
            trainer.dob = trainer.dob.substr(0, 10);
          });
          console.log(this.trainers);
        }
      } catch (e) {
        swal.fire("Error", "Something went wrong", "error");
      }
    },

    getFiltered(e) {
      this.filteredData = e;
    },

    parseDate(date) {
      return new Date(date).toISOString().substr(0, 10);
    },

    editItem(item) {
      this.editedIndex = this.trainers.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },
    close() {
      this.dialog = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    closeDelete() {
      this.dialogDelete = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    async save() {
      if (this.editedIndex > -1) {
        const trainerId = this.editedItem.trainerId;
        const res = await trainer.putTrainers(trainerId, this.editedItem);
        if (res.status === 204) {
          console.log(res);
          Object.assign(this.trainers[this.editedIndex], this.editedItem);
          swal.fire("Success", "Trainer was updated", "success");
        } else {
          console.log(res);
          swal.fire({
            icon: "error",
            title: "Oops...",
            text: "Something went wrong!",
          });
        }
      } else {
        console.log("push");
        this.trainers.push(this.editedItem);
      }
      this.close();
    },
  },
};
</script>

<style>
</style>
